
typedef struct twoIntStruct
{
	int i1;
	int i2;
} twoIntStruct;

typedef struct structWithNestedStructs
{
	int i1;
	int i2;
	struct
	{
		int j1;
		int j2;
	} x;
	struct
	{
		int k1;
		int k2;
	} y;
} structWithNestedStructs;

typedef struct cloneStructWithNestedStructs
{
	int i1;
	int i2;
	struct
	{
		int j1;
		int j2;
	} x;
	struct
	{
		int k1;
		int k2;
	} y;
} cloneStructWithNestedStructs;

typedef struct cloneStructWithRenamedNestedStructs
{
	int m1;
	int m2;
	struct
	{
		int p1;
		int p2;
	} a;
	struct
	{
		int t1;
		int t2;
	} b;
} cloneStructWithRenamedNestedStructs;

typedef struct structWithOneNestedStruct
{
	int i1;
	int i2;
	struct 
	{
		int j1;
		int j2;
		int j3;
		int j4;
	} x;
} structWithOneNestedStruct;

typedef struct structWithNestedUnions
{
	int i1;
	int i2;
	union
	{
		int j1;
		char j1_bytes[4];
	} x;
	union
	{
		int j2;
		char j2_bytes[4];
	} y;
	union
	{
		unsigned int k1;
		char k1_bytes[4];
	} z;
	union
	{
		struct
		{
			int m1a;
			int m2b;
		} a;
		char m1_bytes[8];
	} b;
} structWithNestedUnions;

typedef union unionWithNestedStructs
{
	struct
	{
		int i1;
		int i2;
		int i3;
	} x;
	struct
	{
		unsigned int j1;
		unsigned int j2;
		unsigned int j3;
	} y;
	char bytes[12];
} unionWithNestedStructs;

typedef int (*MathFunction)(int x, int y);

typedef void (*VoidFunction)();

int *getLocalIntPointer(int i);

int *getStaticIntPointer();

int *returnPassedIntPointer(int *i);

void printValueAtPassedIntPointer(int *i);

void ptrPrintValuesInSingleTwoIntStruct(struct twoIntStruct *tis);

void printValuesInSingleTwoIntStruct(struct twoIntStruct tis);

void ptrPrintValuesInArrayOfTwoIntStructs(struct twoIntStruct (*tisArray)[3], int arrayLength);

void printValuesInArrayOfTwoIntStructs(struct twoIntStruct tisArray[3], int arrayLength);

void printValuesInArrayOfPointersToTwoIntStructs(struct twoIntStruct *tisArray[3], int arrayLength);

volatile int printAndReturnVolatileInt(volatile int i);

void printAGlobalString();

void printAHardcodedString();

void callVoidReturningFunctionWithNoParams(void (*vr_func)());

void callPAGSViaWrapper();

int addTwoInts(int a, int b);

MathFunction getMathFunction(int x, int y);

int doMathViaFunctionPointerRV(int u, int v);

extern structWithNestedStructs globalStructWithNestedStructs;

extern cloneStructWithNestedStructs globalCloneStructWithNestedStructs;

extern cloneStructWithRenamedNestedStructs globalCloneStructWithRenamedNestedStructs;

extern structWithOneNestedStruct globalStructWithOneNestedStruct;

extern structWithNestedUnions globalStructWithNestedUnions;

extern unionWithNestedStructs globalUnionWithNestedStructs;

void printVariadicStrings(int count, ...);

void printValuesInStructWithNestedStructs(structWithNestedStructs sns);

void ptrPrintValuesInStructWithNestedStructs(structWithNestedStructs *sns);

void printValuesInCloneStructWithNestedStructs(cloneStructWithNestedStructs clone);

void ptrPrintValuesInCloneStructWithNestedStructs(cloneStructWithNestedStructs *clone);

void printValuesInCloneStructWithRenamedNestedStructs(cloneStructWithRenamedNestedStructs cloneRenamed);

void ptrPrintValuesInCloneStructWithRenamedNestedStructs(cloneStructWithRenamedNestedStructs *cloneRenamed);

/*
void printValuesInConstStaticArrayOfTwoIntStructs(const static struct twoIntStruct (*tisArray)[], int arrayLength);

void printValuesInSingleConstStaticTwoIntStruct(const static struct twoIntStruct *tis);

void printValuesInConstStaticArrayOfTwoIntStructs(const static struct twoIntStruct (*tisArray)[], int arrayLength);
*/

